#include "pad.h"
extern int yesno;

/* 
   bcd
   converts byte format to bcd format 
   returns 16bit bcd value
 */
unsigned char 
bcd (int val)
{
/* return((val/10)<<4 | (val%10)); */

  static unsigned char bcdval[100] =
  {
    0x0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9, 0x10, 0x11, 0x12, 0x13,
    0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x20, 0x21, 0x22, 0x23, 0x24, 0x25,
    0x26, 0x27, 0x28, 0x29, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,
    0x38, 0x39, 0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49,
    0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x60, 0x61,
    0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x70, 0x71, 0x72, 0x73,
    0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x80, 0x81, 0x82, 0x83, 0x84, 0x85,
    0x86, 0x87, 0x88, 0x89, 0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97,
    0x98, 0x99
  };
  return (bcdval[val]);
}

/*
   initfile
   checks if file is divisible by 2352 (1/75th of a second).  
   Prompts and pads nulls to end of file.
   returns new byte count
 */
int 
initfile (char *filename)
{
  FILE *fp;
  int bytes = 0;
#if 0
  char message[255];
  int remain;
  int i;
#endif

  fp = fopen (filename, "r+");

  if (fp == NULL)
    {
      printf ("error opening file\n");
      return 0;
    }

  fseek (fp, 0, SEEK_END);
  bytes = ftell (fp);

#if 0
  printf ("bytes total = %d\n", bytes);  


  remain = (2352 - (bytes % 2352));

  if (remain != 2352)
    {
      sprintf (message, "%s\nnot divisible by 2352 bytes.\nPadd %d extra bytes to\n the end of file?\n", filename, remain);
      paddit (message);

      if (yesno)
	for (i = 0; i < remain; i++)
	  {
	    putc (0, fp);  
	    bytes++;
	  }
    }
#endif 
  fclose (fp);
  return bytes;
}

int 
filesize (char *filename)
{
  FILE *fp;
  int bytes = 0;

  fp = fopen (filename, "r+");

  if (fp == NULL)
    {
      printf ("Error opening file\n");
      return 0;
    }

  fseek (fp, 0, SEEK_END);
  bytes = ftell (fp);
  fclose (fp);
  return bytes;
}

/*
   leader
   makes a lead-in and lead-out null data file
   int leader(char *filename, int bytes)
   {
   FILE *fp;
   int i;

   fp = fopen (filename, "w");
   if(fp == NULL)
   {
   printf("error Opening file\n");
   return(0);
   }

   for(i=0;i<bytes;i++)                                         
   putc(0,fp);          

   fclose(fp);
   return(bytes);
   }
 */

/*
   autogap
   puts bytes of gap at the end of the file
   returns new byte value
 */
int 
autogap (char *filename, int bytes)
{
/* adds bytes of silence to end of file */
  FILE *fp;
  int i;
  int bytecount;

  fp = fopen (filename, "r+");

  if (fp == NULL)
    {
      printf ("error opening file\n");
      return 0;
    }

  fseek (fp, 0, SEEK_END);
  bytecount = ftell (fp);

  for (i = 0; i < bytes; i++)
    putc (0, fp);

  return (bytecount + bytes);
}


/* returns 16 bit crc code based on input */
/* Special thanks to Mark Heath for supplying this code */
unsigned short 
crc (unsigned char *input)
{
/* crc ccitt lookup table based on the polynomial
 * x^16+x^12+x^5+1  produced by rotating and or'ing
 * the bit mask 0x1021 = (2^16 + 2^12 + 2^5 + 2^0) & 0xFFFF
 */
  static unsigned int crctttab[256] =
  {
    0x0000, 0x1021, 0x2042, 0x3063, 0x4084, 0x50A5, 0x60C6, 0x70E7,
    0x8108, 0x9129, 0xA14A, 0xB16B, 0xC18C, 0xD1AD, 0xE1CE, 0xF1EF,
    0x1231, 0x0210, 0x3273, 0x2252, 0x52B5, 0x4294, 0x72F7, 0x62D6,
    0x9339, 0x8318, 0xB37B, 0xA35A, 0xD3BD, 0xC39C, 0xF3FF, 0xE3DE,
    0x2462, 0x3443, 0x0420, 0x1401, 0x64E6, 0x74C7, 0x44A4, 0x5485,
    0xA56A, 0xB54B, 0x8528, 0x9509, 0xE5EE, 0xF5CF, 0xC5AC, 0xD58D,
    0x3653, 0x2672, 0x1611, 0x0630, 0x76D7, 0x66F6, 0x5695, 0x46B4,
    0xB75B, 0xA77A, 0x9719, 0x8738, 0xF7DF, 0xE7FE, 0xD79D, 0xC7BC,
    0x48C4, 0x58E5, 0x6886, 0x78A7, 0x0840, 0x1861, 0x2802, 0x3823,
    0xC9CC, 0xD9ED, 0xE98E, 0xF9AF, 0x8948, 0x9969, 0xA90A, 0xB92B,
    0x5AF5, 0x4AD4, 0x7AB7, 0x6A96, 0x1A71, 0x0A50, 0x3A33, 0x2A12,
    0xDBFD, 0xCBDC, 0xFBBF, 0xEB9E, 0x9B79, 0x8B58, 0xBB3B, 0xAB1A,
    0x6CA6, 0x7C87, 0x4CE4, 0x5CC5, 0x2C22, 0x3C03, 0x0C60, 0x1C41,
    0xEDAE, 0xFD8F, 0xCDEC, 0xDDCD, 0xAD2A, 0xBD0B, 0x8D68, 0x9D49,
    0x7E97, 0x6EB6, 0x5ED5, 0x4EF4, 0x3E13, 0x2E32, 0x1E51, 0x0E70,
    0xFF9F, 0xEFBE, 0xDFDD, 0xCFFC, 0xBF1B, 0xAF3A, 0x9F59, 0x8F78,
    0x9188, 0x81A9, 0xB1CA, 0xA1EB, 0xD10C, 0xC12D, 0xF14E, 0xE16F,
    0x1080, 0x00A1, 0x30C2, 0x20E3, 0x5004, 0x4025, 0x7046, 0x6067,
    0x83B9, 0x9398, 0xA3FB, 0xB3DA, 0xC33D, 0xD31C, 0xE37F, 0xF35E,
    0x02B1, 0x1290, 0x22F3, 0x32D2, 0x4235, 0x5214, 0x6277, 0x7256,
    0xB5EA, 0xA5CB, 0x95A8, 0x8589, 0xF56E, 0xE54F, 0xD52C, 0xC50D,
    0x34E2, 0x24C3, 0x14A0, 0x0481, 0x7466, 0x6447, 0x5424, 0x4405,
    0xA7DB, 0xB7FA, 0x8799, 0x97B8, 0xE75F, 0xF77E, 0xC71D, 0xD73C,
    0x26D3, 0x36F2, 0x0691, 0x16B0, 0x6657, 0x7676, 0x4615, 0x5634,
    0xD94C, 0xC96D, 0xF90E, 0xE92F, 0x99C8, 0x89E9, 0xB98A, 0xA9AB,
    0x5844, 0x4865, 0x7806, 0x6827, 0x18C0, 0x08E1, 0x3882, 0x28A3,
    0xCB7D, 0xDB5C, 0xEB3F, 0xFB1E, 0x8BF9, 0x9BD8, 0xABBB, 0xBB9A,
    0x4A75, 0x5A54, 0x6A37, 0x7A16, 0x0AF1, 0x1AD0, 0x2AB3, 0x3A92,
    0xFD2E, 0xED0F, 0xDD6C, 0xCD4D, 0xBDAA, 0xAD8B, 0x9DE8, 0x8DC9,
    0x7C26, 0x6C07, 0x5C64, 0x4C45, 0x3CA2, 0x2C83, 0x1CE0, 0x0CC1,
    0xEF1F, 0xFF3E, 0xCF5D, 0xDF7C, 0xAF9B, 0xBFBA, 0x8FD9, 0x9FF8,
    0x6E17, 0x7E36, 0x4E55, 0x5E74, 0x2E93, 0x3EB2, 0x0ED1, 0x1EF0
  };

  int l;
  unsigned short crctt;

  crctt = 0;
  for (l = 0; l != 10; l++)
    crctt = (crctt << 8) ^ crctttab[(crctt >> 8) ^ input[l]];
  return crctt;
}


int 
isrc (char *country, char *owner, char *year, char *serialno)
{
  return 0;
/*
   CHAR CODE
   0 0x00
   1 0x01
   2 0x02
   3 0x03
   4 0x04
   5 0x05
   6 0x06
   7 0x07
   8 0x08
   9 0x09
   A 0x11
   B 0x12
   C 0x13
   D 0x14
   E 0x15
   F 0x16
   G 0x17
   H 0x18
   I 0x19
   J 0x1a
   K 0x1b
   L 0x1c
   M 0x1d
   N 0x1e
   O 0x1f
   P 0x20
   Q 0x21
   R 0x22
   S 0x23
   T 0x24
   U 0x25
   V 0x26
   W 0x27
   X 0x28
   Y 0x29
   Z 0x2a
 */
}
